from cryptography.hazmat.primitives import hashes, serialization
from cryptography.hazmat.primitives.asymmetric import padding
import sys
import base64

#priv key
with open("rsa_priv.pem", "rb") as f:
    private_key = serialization.load_pem_private_key(f.read(), password=None)

with open("input.txt", "rb") as f:
    data = f.read()
print("Dane wejściowe (input.txt):", data)

# oliczanie hashu SHA3-256
digest = hashes.Hash(hashes.SHA3_256())
digest.update(data)
hash_val = digest.finalize()
print("Hash SHA3-256:", hash_val.hex())

signature = private_key.sign(
    hash_val,
    padding.PKCS1v15(),
    hashes.SHA3_256()
)
print("Podpis (base64):", base64.b64encode(signature).decode())

with open("input.txt.sig", "wb") as f:
    f.write(signature)

print("podpis zapisany jako input.txt.sig")
