from cryptography.hazmat.primitives import hashes, serialization
from cryptography.hazmat.primitives.asymmetric import padding
import base64


with open("rsa_pub.pem", "rb") as f:
    public_key = serialization.load_pem_public_key(f.read())


with open("input.txt", "rb") as f:
    data = f.read()
print("Dane wejściowe (input.txt):", data)


with open("input.txt.sig", "rb") as f:
    signature = f.read()
print("Podpis (base64):", base64.b64encode(signature).decode())


# oliczanie skrótu SHA3-256
digest = hashes.Hash(hashes.SHA3_256())
digest.update(data)
hash_val = digest.finalize()
print("Hash SHA3-256:", hash_val.hex())


try:
    public_key.verify(
        signature,
        hash_val,
        padding.PKCS1v15(),
        hashes.SHA3_256()
    )
    print("Podpis poprawny")
except Exception:
    print("Podpis niepoprawny!!!")
